/**
 * Memoize decorator
 * @constructor
 */
export declare function Memoize(): (target: any, propertyKey: string, descriptor: PropertyDescriptor) => void;
/**
 * Memoize function
 * @param projectionFn
 * @param comparatorFn
 */
export declare function memoize(projectionFn: ProjectionFn, comparatorFn?: ComparatorFn): any;
export declare type ProjectionFn = (...args: any[]) => any;
export declare type ComparatorFn = (a: any, b: any) => boolean;
export declare type MemoizedProjection = {
    memoized: ProjectionFn;
    reset: () => void;
    setResult: (result?: any) => void;
};
export declare function isEqualCheck(a: any, b: any): boolean;
